import mariadb as mdb
import json
import sys
import os

from httputils import parse_query, escape_sql_string

def readfile(path):
    if os.path.exists(path):
        return open(path).read()

args = {"host": "127.0.0.1",
        "port": 3306,
        "user": "root",
        "password": "",
        "database": "test_holder"}

settings = json.loads(readfile("cgi/db-settings.json"))
args.update(settings)

db_connection = mdb.connect(**args)

args = parse_query(os.environ['QUERY_STRING'])

if not 'id' in args:
    print("Content-Type: text/plain; charset=UTF-8\r\n\r\nВи не зазначили ідентифікатор тесту\r\n")
    sys.exit(0)

if not 'name' in args:
    print("Content-Type: text/plain; charset=UTF-8\r\n\r\nВи не зазначили назву тесту\r\n")
    sys.exit(0)

cur = db_connection.cursor()

try:
    cur.execute(f"UPDATE test SET name = '{escape_sql_string(args['name'])}' WHERE id = {args['id']};")
    db_connection.commit()

    #cur.execute(f"SELECT id FROM question ORDER BY id DESC;")

    #new_id = iter(cur).__next__()[0]
    print(f"Location: /index.py?mode=view-test&id={args['id']}\r\n\r\n")
except Exception as e:
    print(f"Content-Type: text/plain; charset=UTF-8\r\n\r\nНе вдалося змінити тест ({e})\r\n")
